﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace RibbonViewTheme
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            StyleManager.ApplicationTheme = new VistaTheme();
            InitializeComponent();
        }

        public Theme ThisApplicationTheme
        {
            get { return StyleManager.ApplicationTheme; }
            set
            {
                StyleManager.ApplicationTheme = value;
                var binding = new Binding("ThisApplicationTheme") { Source = this, Mode = BindingMode.OneWay };
                foreach (Window window in Application.Current.Windows)
                {
                    foreach (var element in GetWindow(window).ChildrenOfType<FrameworkElement>().ToList())
                    {
                        element.SetBinding(StyleManager.ThemeProperty, binding);
                    }
                }

                Application.Current.MainWindow.SetBinding(StyleManager.ThemeProperty, binding);
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            switch ((e.OriginalSource as Button).Content.ToString())
            {
                case "Office_Black":
                    ThisApplicationTheme = new Office_BlackTheme();
                    break;
                case "Windows8":
                    ThisApplicationTheme = new Windows8Theme();
                    break;
                case "Expression_Dark":
                    ThisApplicationTheme = new Expression_DarkTheme();
                    break;
            }
        } 
    }
}
